/* esListeInserisciOrdinato.cpp
 
   Scrivere una funzione void inserisciOrdinato(...) che prende in ingresso 
   una lista di interi (supposta gia' ordinata) e un nuovo
   intero da inserire, ed inserisce nella lista l'intero in una
   posizione tale da farla rimanere ordinata.

   Scrivere un programma che:
   - crea una lista vuota;
   - legge 6 interi da tastiera;
   - li inserisce in modo ordinato nella lista mediante la
     funzione inserisciOrdinato(...);
   - stampa la lista risultante.

   Output di esempio:
   Inserisci 6 numeri:
   -3
   6
   4
   0
   -2
   4
   Risultato:
   -3 -2 0 4 4 6 

*********************************************************/

#include <iostream>
using namespace std;

struct elem {
   int info;
   elem* pun;
};

void inserisciOrdinato(elem*& L, int n) {
   elem* p = L;
   elem* q;

   // cerco la posizione in cui inserire l'elemento
   while (p != nullptr && p->info < n) 
   {
      q = p;
      p = p->pun;
   }

   // cerco la posizione in cui inserire l'elemento
   elem* r = new elem;
   r->info = n;

   if(p == L) {
      // lista vuota o inserimento in testa
      L = r;
      r->pun = p;
   }
   else {  
      // inserimento in mezzo o in fondo
      q->pun = r;
      r->pun = p;
   }
}

void stampa(elem* L) {
   for(elem* p = L; p != nullptr; p = p->pun)
      cout << p->info << ' ';
}

int main() {
   elem* L0 = nullptr;
   int n;

   cout << "Inserisci 6 numeri:" << endl;
   for(int i = 0; i < 6; i++) {
      cin >> n;
      inserisciOrdinato(L0, n);
   }
   cout << "Risultato:" << endl;
   stampa(L0);

   return 0;
}
