/**************************************************************************
esPlaylist.cpp

  PRIMA PARTE:
  Programmare le operazioni che gestiscono una struttura dati playlist. 
  Una playlist contiene una lista di album musicali. Ogni album musicale 
  e' caratterizzato da un titolo univoco di lunghezza massima 63 
  caratteri. La playlist non può contenere due album con lo stesso nome.
  All'inizio la playlist è vuota.

  Utilizzare la seguente struttura dati:

  struct elem {
	  char titolo[64];
	  elem* pun;
  };

  Realizzare le seguenti funzioni:

- stampa(L): funzione che stampa tutti gli album contenuti nella playlist
  L, rappresentata dal suo puntatore di testa.

- aggiungi(L, alb): funzione che aggiunge l'album di nome alb alla 
  playlist L. Un album il cui nome è più lungo di 63 caratteri o gia'
  presente nella lista non viene inserito. La funzione restituisce 1 
  se alb viene inserito correttamente in L, 0 altrimenti.

  Utilizzare il seguente main di prova:

int main() {

	elem* L0;

	L0 = nullptr; // Playlist vuota
	stampa(L0);

	//test aggiungi
	aggiungi(L0, "titolo1 (autore1)");
	aggiungi(L0, "titolo2 (autore1)");
	aggiungi(L0, "titolo3 (autore2)");
	aggiungi(L0, "titolo2 (autore1)"); //non viene aggiunto perche'
	                                   //gia' presente
	stampa(L0);

	return 0;
}

  Output del main di test:
Album della playlist:

Album della playlist:
titolo3 (autore2)
titolo2 (autore1)
titolo1 (autore1)

**************************************************************/

#include <iostream>
#include <cstring>

using namespace std;

struct elem {
	char titolo[64];
	elem* pun;
};

void stampa(elem* L) {
	elem* p = L;
	cout << "Album della playlist:" << endl;
	while(p != nullptr) {
		cout << p->titolo<<endl;
		p = p->pun;
	}
	cout << endl;
}

bool aggiungi(elem*& L, const char* alb) {
	//controllo se nome troppo lungo
	if(strlen(alb) > 63) { return false; }
	//controllo se album gia' presente
	elem* p = L;
	while(p != nullptr) {
		if(strcmp(p->titolo, alb) == 0) { return false; }
		p = p->pun;
	}
	//inserimento in testa
	p = L;
	L = new elem;
	strcpy(L->titolo, alb);
	L->pun = p;
	return true;
}

int main() {

    elem* L0;
    L0 = nullptr; // Playlist vuota
    stampa(L0);

    //test aggiungi
    aggiungi(L0, "titolo1 (autore1)");
    aggiungi(L0, "titolo2 (autore1)");
    aggiungi(L0, "titolo3 (autore2)");
    aggiungi(L0, "titolo2 (autore1)"); //non viene aggiunto perche' gia' presente
    stampa(L0);

    return 0;
}
